#include <R.h>
#include <Rmath.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include "R_ext/Memory.h"
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "Rmath.h"
#define NPM 100000 // number of permutations for calculating the p-values for LS statistics

#ifndef erf
#define erf(x) (2*pnorm5((x)*M_SQRT2,0,1,1,0)-1)
#endif
#ifndef erfc
#define erfc(x) (2*pnorm5(-(x)*M_SQRT2,0,1,1,0))
#endif

double UNIFORMRV();
void sampleVitterD(int n,
                      int N,
                      int *s);
void sampleVitterA(int n,
                   int N,
                   int j,
                   int *s);
void LSStat(double *p,
            int *x,
            int *n,
            int len,
            double *LS);
void KSStat(double *p,
            int *x,
            int *n,
            int len,
            double *KS);
void KSStat2(double *p,
             int *x,
             int n,
             int len,
             double *KS);
void LSStat2(double *p,
             int *x,
             int n,
             int len,
             double *LS);
void dsort(double *x,
           int n,
           double *y);
double dmax(double *x,
            int n);
int imax(int *x,
         int n);
void geneSetEnrichmentQT(int *nvarx,// # number of genes
                         int *geneSet,
                         int *numGenesPerSet,
                         int *numSets,
                 //        int *randomSeed,
                         double *pvalueCorr,
                         double *pvalueSetLS,
                         double *pvalueSetKS,
                         double *LS,
                         double *KS);
